#define USAGE "Usage: dralut [-Old] [-kay] [-o] [-n<iters>] [-r<region>] [-F<570nm>] stats_file ... "

#include <stdio.h>
#include <math.h>
#include <string.h>
#define IMP1 1
#define IMP3 3
error( s ) char *s; { fprintf( stderr, "dralut: %s\n", s ); exit(1); }
toupper_str(str) char *str; { for( ; *str!='\0' ; str++ ) *str = toupper(*str);}

#define MAX( A, B ) ( (A)<(B) ? (B) : (A) )
#define MIN( A, B ) ( (A)<(B) ? (A) : (B) )
#define SAME_STR( A, B ) ( 0 == strncmp( A, B, strlen(A) ) )
#define MAX_STR 1024 /* Theoretical max length of line in script file */
char str[MAX_STR];
FILE *fpin=stdin;
FILE *fpout=stdout;
char *filename=NULL;
#define uchar unsigned char
#define ulong unsigned long
#define AREA ((ulong) 256*200)
float f_image[AREA];
uchar r_image[AREA];
short xsize=200;
short ysize=256;
int iters=0;
char o_flag=1;
char k_flag=0;
int reg_val=4;
int nm_val=570;
int f_ind=0;
int nd_on=0;
char old_flag=0;

#define MAX_CLEN 512
typedef struct contour_type {
  int x[MAX_CLEN];
  int y[MAX_CLEN];
  int n;
} CONTOUR, *CONTOURP;
CONTOUR contour[17];

init_contours( contour, top )
CONTOUR *contour;
int top;
{ int i;
  for( i=0; i<=top; i++ ) contour[i].n=0;
}


main(argc, argv)
char **argv;
{
 char ch;
  while ((--argc>0)&&(*++argv)[0] == '-')
  {
    switch((*argv)[1])
    {
      case 'k': k_flag = !k_flag; break;
      case 'o': o_flag = !o_flag; break;
      case 'O': old_flag= !old_flag; break;
      case 'r':
      case 'R': sscanf( *argv + 2, "%d", &reg_val );
		if( reg_val<0 || 8<reg_val ) error("bad -r<region> value");
		break;

      case 'F': sscanf( *argv + 2, "%d", &nm_val );
	        if( nm_val%10 != 0 || nm_val<400 || 700<nm_val )
		  error("bad -F<nm_val>");
		break;

      case 'A':
      case 'a': sscanf( *argv + 2, "%d%1c", &f_ind, &ch );
		if( f_ind<1 || 8<f_ind ) error("bad f_ind");
		nd_on = (ch=='N' || ch=='n');
		break;

      case 'n': sscanf( *argv + 2, "%d", &iters );
		if( iters<0 ) error("bad -n<iters> value");
		break;
  /* case 'z' : if( --argc>0 ) postfix_filename = *++argv;
                 else error(USAGE);
                 break;
  */

      default : error(USAGE); break;
    }
  }
  for( ; argc-->0; )
  {
    filename = *argv++;
    if( (fpin = fopen( filename, "r" )) == NULL )
    {
      fprintf( stderr, "can't open input file: %s\n", filename );
      continue;
    }
    fprintf( stderr, "processing file: %s\n", filename );
    process_file( fpin,  nm_val, reg_val,  f_ind, nd_on );
    fclose( fpin );
  }
  hack_perim( r_image, xsize, ysize );
  if( k_flag ) { write_image( r_image, IMP1, xsize, ysize ); exit(0); }
  mk_contours( contour, r_image, xsize, ysize );
  assign_regions( r_image, xsize, ysize );
  if( old_flag )
  { /* old version */
    linear_interp( contour, r_image, xsize, ysize );
    smooth_perim( r_image, xsize, ysize );
    smooth_image( r_image, xsize, ysize, iters );
    write_image( r_image, IMP1, xsize, ysize );
  }
  else
  {
    interp( f_image, contour, r_image, xsize, ysize );
    smooth_perim( r_image, xsize, ysize );
    f_smooth_image( f_image, xsize, ysize, iters );
    write_image( (uchar *) f_image, IMP3, xsize, ysize );
  }
  exit(0);
}

hack_perim( image, xsize, ysize )
uchar *image;
short xsize, ysize;
{
 int j, cur_ap;
 ulong offs;
  cur_ap=17;
  for( j=0,offs=0; j<ysize-3; j++,offs+=xsize )
  {
     image[offs]=cur_ap;
     if( image[offs+1] != 0 && image[offs+1] != image[offs+xsize+1] )
       cur_ap = image[offs+1];
  }
}

#define TUBE_SENSI 0.435 /* mean at 570nm */
#define FILTER_SUM 6.290892  /* Transmittance summed at 1 nm intervals */
#define TARGET_RAD 0.002 /* Target brightness at 570 nm in W/Sr m^2 nm */
#define LIGHT (TARGET_RAD*FILTER_SUM*TUBE_SENSI)
#define   ND_5 0.320885	/* transmittance of ND filter when used */


float light[17]= { 0.0,
 LIGHT*ND_5/256,
 LIGHT*ND_5/128,
 LIGHT*1.0 /256,
 LIGHT*ND_5/64,
 LIGHT*1.0 /128,
 LIGHT*ND_5/32,
 LIGHT*1.0 /64,
 LIGHT*ND_5/16,
 LIGHT*1.0 /32,
 LIGHT*ND_5/8,
 LIGHT*1.0 /16,
 LIGHT*ND_5/4,
 LIGHT*1.0 /8,
 LIGHT*ND_5/2,
 LIGHT*1.0 /4,
 LIGHT*1.0 /2
};

/* OLD VERSION
float light[17]= { 0.0,
 1.25,  2.51,  3.91,  5.01,  7.81,  10.03, 15.63, 20.06,
31.25, 40.11, 62.50, 80.02, 125.0, 160.44, 250.0, 500.0
};
*/

interp( f_image, contour, r_image, xsize, ysize )
float *f_image;
CONTOUR *contour;
uchar *r_image;
short xsize, ysize;
{
 float val, l[2], r[2], find_nearest();
 char rflag=0;
 ulong offs;
 int i,j;
 int z[2];
  for( j=0,offs=0; j<ysize; j++ )
  {
    for( i=0; i<xsize; i++,offs++ )
    {
      z[0] = r_image[offs]; rflag=0;
      if(z[0]< 1) { f_image[offs] = light[0]; continue; }
      if(z[0]==1) { f_image[offs] = light[1]; continue; }
      if(z[0]>16) { rflag=1; z[0] = 16; }
      z[1]=z[0]-1;
      r[0] = find_nearest( &(contour[z[0]]), i, j );
      r[1] = find_nearest( &(contour[z[1]]), i, j );
      if( rflag ) r[0] = -r[0];
      l[0] = light[z[0]]; l[1] = light[z[1]];
      val = (r[0]*l[1] + r[1]*l[0])/(r[0] + r[1]);
      f_image[offs]=val;
    }
    if( j%32==0 ) fprintf( stderr, "linear_interp: %3d/%d\n", j, ysize );
  }
}

linear_interp( contour, r_image, xsize, ysize )
CONTOUR *contour;
uchar *r_image;
short xsize, ysize;
{
#define R_CONV( A ) ( 16*A-1 )
 float val, r[2], find_nearest();
 char rflag=0;
 ulong offs;
 int i,j;
 int z[2];
  for( j=0,offs=0; j<ysize; j++ )
  {
    for( i=0; i<xsize; i++,offs++ )
    {
      z[0] = r_image[offs]; rflag=0;
      if(z[0]< 1) { r_image[offs] = 0; continue; }
      if(z[0]==1) { r_image[offs] = R_CONV(1); continue; }
      if(z[0]>16) { rflag=1; z[0] = 16; }
      z[1]=z[0]-1;
      r[0] = find_nearest( &(contour[z[0]]), i, j );
      r[1] = find_nearest( &(contour[z[1]]), i, j );
      if( rflag ) r[0] = -r[0];
      val = (r[0]*z[1] + r[1]*z[0])/(r[0] + r[1]);
      val = R_CONV(val);
      if( 255.0<val ) val = 255.0;
      r_image[offs] = val;
    }
    if( j%32==0 ) fprintf( stderr, "linear_interp: %3d/%d\n", j, ysize );
  }
}

float find_nearest( c_ptr, i, j )
CONTOUR *c_ptr;
int i, j;
{
 ulong r_2, min_r_2;
 int *x, *y;
 int n;
  x = c_ptr->x; y = c_ptr->y;
  min_r_2 = (*x-i)*(*x-i) + (*y-j)*(*y-j);
  if(  min_r_2 == 0 ) return(0);

  for( n=c_ptr->n,n--,x++,y++; n-->0; x++,y++ )
  {
     r_2 = (*x-i)*(*x-i) + (*y-j)*(*y-j);
     if( min_r_2 < r_2 ) continue;
     min_r_2 = r_2;
     if( min_r_2==0 ) return(0);
  }
  return( sqrt( (double) min_r_2 ) );
}

mk_contours( contour, image, xsize, ysize )
CONTOUR *contour;
uchar *image;
short xsize, ysize;
{
 CONTOUR *c_ptr;
 ulong offs;
 int i,j,n,val;
  init_contours( contour, 16 );
  for( j=0,offs=0; j<ysize; j++ )
  {
    for( i=0; i<xsize; i++,offs++ )
    {
      val = image[offs];
      if( val<1 || 16<val ) continue;
      c_ptr = &(contour[val]);
      n = c_ptr->n;
      if( n < MAX_CLEN )
      { c_ptr->x[n] = i; c_ptr->y[n] = j; c_ptr->n = c_ptr->n + 1; }
    }
  }
}

assign_regions( image, xsize, ysize )
uchar *image;
short xsize, ysize;
{
 ulong offs;
 int i,j;
  image[1] = 17;
  for( j=0; j<ysize-3; j++ )
  {
    for( i=1,offs=i+j*xsize; i<xsize; i++,offs++ ) if( image[offs]==0 )
    {
      if( 1<i ) image[offs] = image[offs-1];
      else
      if( 0<j ) image[offs] = image[offs-xsize];
    }
  }
}

process_file( fpin, nm_val, reg_val,  f_ind, nd_on )
FILE *fpin;
int nm_val, reg_val;
int f_ind, nd_on;
{
 char hash_str[64], ap_str[64], calib_str[64], reg_str[64], median_str[64];
 int reg, nm;
  for( ; ; )
  {
    if( fgets( str, MAX_STR, fpin ) == NULL ) break; /* EOF */
    toupper_str( str );
    if( 7 != sscanf( str, "%s %d %s %s %s %s %d", hash_str, &nm, ap_str,
		 calib_str, reg_str, median_str, &reg ) )
      continue;
    if( !SAME_STR( "###", hash_str ) ) continue;
    if( nm_val != nm || reg_val != reg ) continue;
    if( ap_str[0] != 'F' ) continue;
    if( !SAME_STR( "CALIB", calib_str ) ) continue;
    if( !SAME_STR( "MEDIAN", median_str ) ) continue;
    if( reg_str[0] != 'R' ) continue;
    if( EOF == process_run( fpin, ap_str,  f_ind, nd_on )) break;
  }
}

/*
int z_array[2][9] = {
  { 0, 56, 84, 113, 141, 170, 198, 227, 255 }, 
  { 0, 9, 38, 66, 95,  123, 151, 180, 208 } 
};
*/


int aper_id[2][9] = {
  { 0, 3, 5, 7, 9, 11, 13, 15, 16 }, /* no nd */
  { 0, 1, 2, 4, 6,  8, 10, 12, 14 }  /* with nd */
};

process_run( fpin, ap_str,  f_ind, nd_on )
FILE *fpin;
char *ap_str;
int f_ind, nd_on;
{
 int f_index, z_val;
 int it[3], g[3];
 char ch[2];
  sscanf( ap_str, "%*1c%*f%*1c%d%1c", &f_index, ch );
  if( f_index<1 || 8<f_index ) return(0);
  if( (f_ind && (f_ind!=f_index || nd_on!=(ch[0]=='N')) )) return(0);
  z_val = (ch[0]=='N');
  z_val = aper_id[z_val][f_index];
  /* if( k_flag ) z_val = 12*z_val +63 */
  if( k_flag ) z_val = 16*z_val-1;
  g[0]=g[1]=g[2]=it[0]=it[1]=it[2]=0;
  for( ; ; )
  {
    if( fgets( str, MAX_STR, fpin ) == NULL ) return( EOF );
    if( str[0] == '#' ) return(1);
    if(2 != sscanf( str, "%d %d", &(it[0]), &(g[0]) )) return(0);
    if( it[0]<0 || xsize<=it[0] || g[0]<0 || ysize<=g[0] ) continue;
    if( it[1] != 0 )
    {
      if( g[0]<g[1] ) g[0]=g[1]; /* ensure monotonic */
      if( g[0]==ysize-1 ) myclip_line( it, g );
      draw_line( r_image, it[1], ysize-1-g[1], it[0], ysize-1-g[0],
		 (int) xsize, z_val, o_flag );
    }
    it[2] = it[1]; it[1] = it[0]; g[2] = g[1]; g[1] = g[0];
    /* fprintf( fpout, "%3d\t%3d\t%2d\n", it[0], g[0], z_val ); */
  }
}

myclip_line( x, y )
int x[3], y[3];
{
 int del_x, del_y, new_x;
  if( y[2]==0 ) return(0);
  del_y =  y[1] -  y[2];
  if( del_y == 0 ) return(0);
  del_x =  x[1] -  x[2];
  new_x = (y[0] - y[1])*del_x/((float) del_y) + 0.5;
  new_x += x[1];
  x[0] = MIN( xsize-1, new_x );
}

write_image( image, type, xsize, ysize )
uchar *image;
short type, xsize, ysize;
{
 ulong area;
  if( type!=IMP1 && type!=IMP3 ) error("image of wrong type");
  if( (fpout = fopen( "dralut.imp", "w" )) == NULL )
    error("can't write to file: dralut.imp");
  write_imp_hdr( fileno(fpout), type, xsize, ysize );
  area = xsize*ysize;
  if( type==IMP3 ) area = area*sizeof(float);
  write_bytes( fileno(fpout), image, area );
  fclose( fpout );
}

#include <sys/file.h>
#define IMPHDRLEN 32
#define O_NDELAY 0 /* blocking input/output */

write_bytes(fd,cp,b) /* blocking write */
register int fd, b;
register unsigned char *cp;
{
register int n;
  for( ; 0<b; b-=n, cp+=n)
    n = write(fd,cp,b);
  return(n);
}

write_imp_hdr(fdout,type,xsize,ysize)
int fdout;
short  type, xsize, ysize;
{ long *lbuf; char *buf;
  buf = (char *) malloc( IMPHDRLEN ); lbuf = (long *) buf;
  sprintf(buf,"DFIMAG10");
  lbuf[2] = IMPHDRLEN; lbuf[3] = xsize; lbuf[4] = ysize;
  lbuf[5] = type;
  lbuf[6] = 0; lbuf[7] = 0;
  write_bytes( fdout, buf, IMPHDRLEN );
  free(buf);
}


swap_coords( x,y, x2,y2 )
int *x,*y, *x2,*y2;
{ int tmp; tmp = *x2;  *x2 = *x; *x = tmp; tmp = *y2;  *y2 = *y; *y = tmp; }

draw_line( image, x, y, x2, y2, xsize, val, o_flag )
uchar *image;
int x,y, x2,y2, xsize, val;
char o_flag;
{
 int dx,dy,i,j,e;
 unsigned char *im_ptr;
  if( x2<x ) swap_coords( &x,&y, &x2,&y2 ); /* ensure that x <= x2 */
  dx = x2-x; dy = y2-y;
  im_ptr = &(image[x + y*xsize]);
  if( 0 <= dy )
  {
    if( dy <= dx )
    {
      for( i=0,e=2*dy-dx; i<=dx; i++,im_ptr++,e+=2*dy )
      {
        if( !o_flag || *im_ptr < val ) *im_ptr = val;
	if( 0<e ) { im_ptr+=xsize; e-=2*dx; }
      }
    }
    else
    {
      for( j=0,e=2*dx-dy; j<=dy; j++,im_ptr+=xsize,e+=2*dx )
      {
        if( !o_flag || *im_ptr < val ) *im_ptr = val;
	if( 0<e ) { im_ptr++; e-=2*dy; }
      }
    }
  }
  else
  {
    dy = -dy; /* ensure 0 < dy  */
    if( dy <= dx )
    {
      for( i=0,e=2*dy-dx; i<=dx; i++,im_ptr++,e+=2*dy )
      {
        if( !o_flag || *im_ptr < val ) *im_ptr = val;
	if( 0<e ) { im_ptr-=xsize; e-=2*dx; }
      }
    }
    else
    {
      for( j=0,e=2*dx-dy; j<=dy; j++,im_ptr-=xsize,e+=2*dx )
      {
        if( !o_flag || *im_ptr < val ) *im_ptr = val;
	if( 0<e ) { im_ptr++; e-=2*dy; }
      }
    }
  }
}

cp_buf( out, in, n )
register uchar *out, *in;
register int n;
{ for( ; n-->0; ) *out++ = *in++; }


#define ODD( A ) ( (A)%2==1 )

smooth_image( image, xsize, ysize, iters )
uchar *image;
short xsize, ysize;
int iters;
{
 uchar *p1, *p2, *tmp;
 ulong offs, val;
 int i,j,count,n;
 uchar tmpimage[AREA];
  cp_buf( tmpimage, image, xsize*ysize );
  p1=image; p2=tmpimage;
  for( n=1; n<=iters; n++, tmp=p1,p1=p2,p2=tmp )
  {
    fprintf( stderr, "smoothing %3d/%d\n", n, iters );
    for( j=0,offs=0; j<ysize-4; j++ )
      for( i=0, offs=j*xsize+i; i<xsize; i++,offs++ )
      {
        if( (val=p1[offs]) ==0 ) p2[offs] = 0;
        else
        {
          count=1;
          if( 0<i )      { count++; val+=p1[offs-1]; }
          if( 0<j )      { count++; val+=p1[offs-xsize]; }
          if( i!=0 && i<xsize-1 ){ count++; val+=p1[offs+1]; }
          if( j<ysize-1 ){ count++; val+=p1[offs+xsize]; }
          p2[offs] =  (val+count/2)/count; /* integer rounding */
        }
      }
  }
  if( ODD(iters) ) cp_buf( image, tmpimage, xsize*ysize );
}

f_smooth_image( image, xsize, ysize, iters )
float *image;
short xsize, ysize;
int iters;
{
 float val, *p1, *p2, *tmp;
 ulong offs;
 int i,j,count,n;
 float tmpimage[AREA];
  cp_buf( tmpimage, image, xsize*ysize*sizeof(float) );
  p1=image; p2=tmpimage;
  for( n=1; n<=iters; n++, tmp=p1,p1=p2,p2=tmp )
  {
    fprintf( stderr, "smoothing %3d/%d\n", n, iters );
    for( j=0,offs=0; j<ysize-4; j++ )
      for( i=0, offs=j*xsize+i; i<xsize; i++,offs++ )
      {
        if( (val=p1[offs]) ==0.0 ) p2[offs] = 0.0;
        else
        {
          count=1;
          if( 0<i )      { count++; val+=p1[offs-1]; }
          if( 0<j )      { count++; val+=p1[offs-xsize]; }
          if( i!=0 && i<xsize-1 ){ count++; val+=p1[offs+1]; }
          if( j<ysize-1 ){ count++; val+=p1[offs+xsize]; }
          p2[offs] =  val/count; 
        }
      }
  }
  if( ODD(iters) ) cp_buf( image, tmpimage, xsize*ysize );
}

typedef struct run_struct {
  int val, start, end; 
} RUN, *RUNP;


smooth_perim( r_image, xsize, ysize )
uchar *r_image;
short xsize,ysize;
{
 RUN run[256];
 float val, x_1, x_0;
 int k, j, count;
 char done;

  for( j=done=count=0; j<ysize; j++)
  {
    if( !done )
    { /* start next run */
      run[count].start=j;
      run[count].end=0;
      run[count].val = r_image[j*xsize];
      done=1;
      continue;
    }
    if( r_image[j*xsize] == run[count].val ) continue; 
    /* finish old run */
    j--;
    run[count].end = j;
    count++;
    done=0;
  }
  if( done && run[count].end==0 )
  {
    run[count].end=j-1; count++;
  }
  /* fix ends */ 
  run[0].start = run[0].end;
  run[count].end = run[count].start;
  /* smooth perim */
  for( k=1; k<count-1; k++ )
  {
    if( run[k].start == run[k].end ) continue;
    x_0 = (run[k-1].end + run[k-1].start)/2.0;
    x_1 = (run[k+1].end + run[k+1].start)/2.0;
    for( j=run[k].start; j<=run[k].end; j++ )
    {
      val = (run[k-1].val*(x_1 - j) + run[k+1].val*(j - x_0))/(x_1 - x_0);
      r_image[j*xsize] = val + 0.499;
      if( !old_flag )
      {
       int a,b;
	a = val;     if( a<0 ) a=0; if( 16<a ) a=16;
	b = val + 1; if( b<0 ) b=0; if( 16<b ) b=16;
	val = val-a;
        f_image[j*xsize] = val*light[b] + (1.0-val)*light[a];
      }
    }
  }
  if( !old_flag ) for( j=0; j<=run[0].start; j++ )
  {
    f_image[j*xsize] = f_image[j*xsize+1];
  }
}
